import cx from 'clsx';
import { Outlet } from 'react-router-dom';
import { VSegmentedControl } from '../components/VSegmentedControl';
import styles from './Harmonies.module.css';

export function Harmonies() {
  return (
    <div className={cx('workspace', styles.harmonies_workspace)}>
      <header>
        <h3>Color Harmonies</h3>
        <p>Automatically select color combinations using color theory.</p>
      </header>
      <section className={styles.explore_section}>
        <aside className={styles.function_side}>
          <div>
            <h5>Basic color</h5>
          </div>
          <div className={styles.mode_navigation}>
            <h5>Color selection method</h5>
            <VSegmentedControl
              options={[
                { label: 'Complementary', value: 'complementary' },
                { label: 'Analogous', value: 'analogous' },
                { label: 'Analogous with Complementary', value: 'analogous_with_complementary' },
                { label: 'Triadic', value: 'triadic' },
                { label: 'Split Complementary', value: 'split_complementary' },
                { label: 'Tetradic', value: 'tetradic' },
                { label: 'Flip Tetradic', value: 'flip_tetradic' },
                { label: 'Square', value: 'square' },
              ]}
            />
          </div>
        </aside>
        <div className={styles.preview_side}>
          <Outlet />
        </div>
      </section>
    </div>
  );
}
